



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ios 消息跳转处理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ios 消息跳转处理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 11:44:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>一.消息转发流程</h3>
<p>当向Objective-C对象发送一个消息，但runtime在当前类及父类中找不到此selector对应的方法时，消息转发(message forwarding)流程开始启动。</p>
<ol><li>动态方法解析(Dynamic Method Resolution或Lazy method resolution)<br />向当前类(Class)发送<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/clm/NSObject/resolveInstanceMethod:" rel="external nofollow noreferrer">resolveInstanceMethod:</a>(对于类方法则为<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/clm/NSObject/resolveClassMethod:" rel="external nofollow noreferrer">resolveClassMethod:</a>)消息，如果返回YES,则系统认为请求的方法已经加入到了，则会重新发送消息。</li>
<li>快速转发路径(Fast forwarding path)<br />若果当前target实现了<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/instm/NSObject/forwardingTargetForSelector:" rel="external nofollow noreferrer">forwardingTargetForSelector:</a>方法,则调用此方法。如果此方法返回除nil和self的其他对象，则向返回对象重新发送消息。</li>
<li>慢速转发路径(Normal forwarding path)<br />首先runtime发送<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/instm/NSObject/methodSignatureForSelector:" rel="external nofollow noreferrer">methodSignatureForSelector:</a>消息查看Selector对应的方法签名，即参数与返回值的类型信息。如果有方法签名返回，runtime则根据方法签名创建描述该消息的<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSInvocation_Class/Reference/Reference.html" rel="external nofollow noreferrer">NSInvocation</a>，向当前对象发送<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/instm/NSObject/forwardInvocation:" rel="external nofollow noreferrer">forwardInvocation:</a>消息，以创建的NSInvocation对象作为参数；若methodSignatureForSelector:无方法签名返回，则向当前对象发送<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/instm/NSObject/doesNotRecognizeSelector:" rel="external nofollow noreferrer">doesNotRecognizeSelector:</a>消息,程序抛出异常退出。
<pre class="prettyprint linenums"><code>Terminating app due to uncaught exception 'NSInvalidArgumentException', reason: '-[MessageInterceptor test]: unrecognized selector sent to instance 0x9589830'</code></pre></li></ol>
<h3>二.动态解析(Lazy Resolution)</h3>
<p>runtime发送消息的流程即查找该消息对应的方法或IMP,然后跳转至对应的IMP。有时候我们不想事先在类中设置好方法，而想在运行时动态的在类中插入IMP。这种方法是真正的快速&rdquo;转发&rdquo;,因为一旦对应的方法被添加到类中，后续的方法调用就是正常的消息发送流程。此方法的缺点是不够灵活，你必须有此方法的实现(IMP),这意味这你必须事先预测此方法的参数和返回值类型。</p>
<p><a href="http://developer.apple.com/library/ios/documentation/Cocoa/Conceptual/ObjectiveC/Chapters/ocProperties.html#//apple_ref/doc/uid/TP30001163-CH17-SW9" rel="external nofollow noreferrer">@dynamic</a>属性是使用动态解析的一个例子，@dynamic告诉编译器该属性对应的getter或setter方法会在运行时提供，所以编译器不会出现warning； 然后实现<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/clm/NSObject/resolveInstanceMethod:" rel="external nofollow noreferrer">resolveInstanceMethod:</a>方法在运行时将属性相关的方法加入到Class中。</p>
<p>当<a href="http://developer.apple.com/library/ios/#documentation/Cocoa/Reference/Foundation/Protocols/NSObject_Protocol/Reference/NSObject.html#//apple_ref/occ/intfm/NSObject/respondsToSelector:" rel="external nofollow noreferrer">respondsToSelector:</a>或<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/clm/NSObject/instancesRespondToSelector:" rel="external nofollow noreferrer">instancesRespondToSelector:</a>方法被调用时，若该方法在类中未实现，动态方法解析器也会被调用，这时可向类中增加IMP,并返回YES,则对应的respondsToSelector:的方法也返回YES。</p>
<h3>三.快速转发(Fast Forwarding)</h3>
<p>runtime然后会检查你是否想将此消息不做改动的转发给另外一个对象，这是比较常见的消息转发情形，可以用较小的消耗完成。<br />快速转发技术可以用来实现伪多继承，你只需编写如下代码</p>
<pre class="prettyprint linenums"><code>- (id)<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/instm/NSObject/forwardingTargetForSelector:" rel="external nofollow noreferrer">forwardingTargetForSelector:</a>(SEL)sel { return _otherObject; }</code></pre>
<p>这样做会将任何位置的消息都转发给_otherObject对象，尽管当前对象与_otherObject对象是包含关系，但从外界看来当前对象和_otherObject像是同一个对象。<br />伪多继承与真正的多继承的区别在于，真正的多继承是将多个类的功能组合到一个对象中，而消息转发实现的伪多继承，对应的功能仍然分布在多个对象中，但是将多个对象的区别对消息发送者透明。</p>
<h3>四.慢速转发(Normal Forwarding)</h3>
<p>以上两者方式是对消息转发的优化，如果你不使用上述两种方式，则会进入完整的消息转发流程。这会创建一个NSInvocation对象来完全包含发送的消息，其中包括target,selector,所有的参数，返回值。</p>
<p>在runtime构建NSInvocation之前首先需要一个<a href="http://developer.apple.com/library/ios/#documentation/Cocoa/Reference/Foundation/Classes/NSMethodSignature_Class/Reference/Reference.html" rel="external nofollow noreferrer">NSMethodSignature</a>，所以它通过<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html#//apple_ref/occ/instm/NSObject/methodSignatureForSelector:" rel="external nofollow noreferrer">-methodSignatureForSelector:</a>方法请求。一旦NSInvocation创建完成，runtime就会调用forwardInvocation:方法，在此方法内你可以使用参数中的invocation做任何事情。无限可能&hellip;<br />举个例子，如果你想对一个NSArray中的所有对象调用同一个方法，而又不想一直写循环代码时，想直接操作NSArray时，可这样处理:</p>
<pre class="prettyprint linenums"><code>@implementation NSArray (ForwardingIteration)

    - (NSMethodSignature *)methodSignatureForSelector:(SEL)sel<br />
    {<br />
        NSMethodSignature *sig = [super methodSignatureForSelector:sel];<br />
        if(!sig)<br />
        {<br />
            for(id obj in self)<br />
                if((sig = [obj methodSignatureForSelector:sel]))<br />
                    break;<br />
        }<br />
        return sig;<br />
    }

    - (void)forwardInvocation:(NSInvocation *)inv<br />
    {<br />
        for(id obj in self)<br />
            [inv invokeWithTarget:obj];<br />
    }

    @end</code></pre>
<p>然后就可以这样使用</p>
<pre class="prettyprint linenums"><code>[(NSWindow *)windowsArray setHidesOnDeactivate:YES];</code></pre>
<p>不过不建议这样使用，因为若NSArray实现了此方法，就不会进入转发流程。实现这种功能的一种比较好的方法是使用NSProxy。</p>
<h3>五.方法声明</h3>
<p>虽然上述机制可以转发当前类中没有实现的方法，但发送消息时仍然需要知道每个消息的方法签名，否则就会有编译器告警。可以通过category来声明转发消息的方法。</p>
<h3>六.使用消息转发在子类中处理Delegate消息</h3>
<p>当继承一个具有delgate的类,而又需要在子类中处理某些delegate消息，而又不影响对正常Delegate消息的调用时，需要如何处理呢？<br />一种方法是将子类对象设为自身的delegate,而将外部设置的delegate存储到另一个参数中。在子类中实现所有的delegate方法，处理子类中需要处理的delegate消息，而将子类中不处理的delegate消息再发送到外部delegate。这种方法的缺点在于实现繁琐，在子类中需要实现所有delegate方法，尽管大部分delegate消息又直接转给了外部delegate处理。<br />另一种比较优雅的方式是使用消息转发，创建一个proxy类，将proxy类设置为父类的delegate,在proxy中分别将消息转发给子类或外部Delegate。<br />比如，创建一个UISCrollView的子类可使用如下代码<br />MessageInterceptor.h</p>
<pre class="prettyprint linenums"><code>@interface MessageInterceptor : NSObject {<br />
    id receiver;<br />
    id middleMan;<br />
}<br />
@property (nonatomic, assign) id receiver;<br />
@property (nonatomic, assign) id middleMan;<br />
@end</code></pre>
<p>MessageInterceptor.m</p>
<pre class="prettyprint linenums"><code>@implementation MessageInterceptor<br />
@synthesize receiver;<br />
@synthesize middleMan;

- (id)forwardingTargetForSelector:(SEL)aSelector {<br />
    if ([middleMan respondsToSelector:aSelector]) { return middleMan; }<br />
    if ([receiver respondsToSelector:aSelector]) { return receiver; }<br />
    return [super forwardingTargetForSelector:aSelector];<br />
}

- (BOOL)respondsToSelector:(SEL)aSelector {<br />
    if ([middleMan respondsToSelector:aSelector]) { return YES; }<br />
    if ([receiver respondsToSelector:aSelector]) { return YES; }<br />
    return [super respondsToSelector:aSelector];<br />
}

@end</code></pre>
<p>MyScrollView.h</p>
<pre class="prettyprint linenums"><code>#import "MessageInterceptor.h"

@interface MyScrollView : UIScrollView {<br />
    MessageInterceptor * delegate_interceptor;<br />
    //...<br />
}

//...

@end</code></pre>
<p>MyScrollView.m</p>
<pre class="prettyprint linenums"><code>@implementation MyScrollView

- (id)delegate { return delegate_interceptor.receiver; }

- (void)setDelegate:(id)newDelegate {<br />
    [super setDelegate:nil];<br />
    [delegate_interceptor setReceiver:newDelegate];<br />
    [super setDelegate:(id)delegate_interceptor];<br />
}

- (id)init* {<br />
    //...<br />
    delegate_interceptor = [[MessageInterceptor alloc] init];<br />
    [delegate_interceptor setMiddleMan:self];<br />
    [super setDelegate:(id)delegate_interceptor];<br />
    //...<br />
}

- (void)dealloc {<br />
    //...<br />
    [delegate_interceptor release];<br />
    //...<br />
}

// delegate method override:<br />
- (void)scrollViewDidScroll:(UIScrollView *)scrollView {<br />
    // 1. your custom code goes here<br />
    // 2. forward to the delegate as usual<br />
    if ([self.delegate respondsToSelector:@selector(scrollViewDidScroll:)]) {<br />
        [self.delegate scrollViewDidScroll:scrollView];<br />
    }<br />
}

@end</code></pre>
<p>MessageInterceptor对象会自动将将子类中实现的delegate消息转发给子类，而将其他所有delegate消息转发给外部设置的delegate对象。</p>
<p>在MessageInterceptor中除了实现forwardingTargetForSelector:方法外，还实现了respondsToSelector:方法，因为UIScrollView在发送delegate消息之前会首先使用<a href="http://developer.apple.com/library/ios/documentation/Cocoa/Reference/Foundation/Protocols/NSObject_Protocol/Reference/NSObject.html#//apple_ref/occ/intfm/NSObject/respondsToSelector:" rel="external nofollow noreferrer">respondsToSelector:</a>判断delegate是否实现了该方法，而转发的消息对respondsToSelector:也应返回YES。</p>
<p>参考:<br /><a href="http://www.mikeash.com/pyblog/friday-qa-2009-03-27-objective-c-message-forwarding.html" rel="external nofollow noreferrer">Friday Q&amp;A 2009-03-27: Objective-C Message Forwarding</a><br /><a href="http://developer.apple.com/library/ios/documentation/Cocoa/Conceptual/ObjCRuntimeGuide/Articles/ocrtDynamicResolution.html#//apple_ref/doc/uid/TP40008048-CH102-SW1" rel="external nofollow noreferrer">Objective-C Runtime Programming Guide &ndash; Dynamic Method Resolution</a><br /><a href="http://developer.apple.com/library/ios/documentation/Cocoa/Conceptual/ObjCRuntimeGuide/Articles/ocrtForwarding.html#//apple_ref/doc/uid/TP40008048-CH105-SW1" rel="external nofollow noreferrer">Objective-C Runtime Programming Guide &ndash; Message Forwarding</a><br /><a href="http://stackoverflow.com/questions/3498158/intercept-obj-c-delegate-messages-within-a-subclass" rel="external nofollow noreferrer">Intercept obj-c delegate messages within a subclass</a><br /><a href="http://petersteinberger.com/blog/2012/hacking-block-support-into-uimenuitem/" rel="external nofollow noreferrer">Hacking Block Support Into UIMenuItem</a><br /><a href="http://developer.apple.com/library/ios/#documentation/Cocoa/Reference/Foundation/Classes/NSObject_Class/Reference/Reference.html" rel="external nofollow noreferrer">NSObject Class Reference</a><br /><a href="http://developer.apple.com/library/ios/#documentation/Cocoa/Reference/Foundation/Protocols/NSObject_Protocol/Reference/NSObject.html" rel="external nofollow noreferrer">NSObject Protocol Reference</a><br /><a href="http://developer.apple.com/library/ios/#documentation/Cocoa/Reference/Foundation/Classes/NSInvocation_Class/Reference/Reference.html" rel="external nofollow noreferrer">NSInvocation Class Reference</a><br /><a href="http://developer.apple.com/library/ios/#documentation/Cocoa/Reference/Foundation/Classes/NSMethodSignature_Class/Reference/Reference.html" rel="external nofollow noreferrer">NSMethodSignature Class Reference</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1doozq.html">如何自学Android</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwx4zy9.html">Linux修改密码passwd用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8op265q.html">制作caffe中的test&period;txt和val&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932rwgq.html">纯js轮播效果（减速效果）待改进</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvenpzq.html">LPHW-积累-ex1-6</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o7lp49.html">bat面试总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvzppzq.html">POJ 3617 Best Cow Line &lpar;贪心&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qded7179.html">CORTEX -M3 &colon; Registers in depth</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd62e2q.html">HTML-块级元素和内联元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ozy5j9.html">Ubuntu 12&period;04下搭建Qt开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvw3mxq.html">高仿优酷Android客户端图片左右滑动（自动切换）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj463d9.html">C&num;操作Excel（NPOI）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg3d09.html">Libreoffice汉化</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yo0z08.html">Android 之 Fragment</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yxln08.html">SilkTest高级进阶系列9 &ndash; 异步执行命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg0ppr8.html">SBT使用阿里云Maven仓库，解决SBT下载依赖慢。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7jvk8.html">知识扩展--if&period;&period;&period;else&period;&period;&period;与switch&period;&period;&period;case&period;&period;&period;的执行原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rrrr68.html">20145232韩文浩《网络对抗》MSF基础应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r4ox08.html">Oracle表空间迁移Move Tablespace</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyxj1x9.html">如何用区块链技术解决信任问题？Fabric 架构深度解读</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qydx62gq.html">VS&period;NET2010水晶报表安装部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnx6vz8.html">C&num;中属性简写原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmkr149.html">as3&plus;java&plus;mysql&lpar;mybatis&rpar; 数据自动工具（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ogz649.html">利用fgets，fputs的回显程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/96og4649.html">hive0&period;11的编译&sol;安装&sol;配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xkl2z9.html">HTTP的升级产品：SPDY</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e127dm9.html">Linux必学的命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjeyz79.html">Redis在PHP中的基本使用案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvnppoq.html">eclipse安装插件checkstyle</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdmld78.html">Ⅸ&period;spring的点点滴滴--IObjectFactory与IFactoryObject的杂谈</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
